hdu 1973 Prime Path 解题报告

来源:互联网 发布:牛鼻铣刀编程计算 编辑:程序博客网 时间:2024/04/30 08:23

Prime Path

Time Limit: 5000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 301 Accepted Submission(s): 186


Problem Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
—I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
—In fact, I do. You see, there is this programming contest going on. . .

Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input
31033 81791373 80171033 1033

Sample Output
670
解题代码
#include <iostream>#include <stdio.h>#include <cstring>#include <queue>using namespace std;int m,n,flag;int a[10001];int vis[10001];int d[4]= {1,10,100,1000};struct node{    int x;    int step;//记录当前转换的步数};void prime()//素数筛{    memset(a,0,sizeof(a));    a[0]=a[1]=1;    for(int i=2; i<=101; i++)    {        if(!a[i])            for(int j=i*i; j<10001; j+=i)                a[j]=1;    }}queue<node> q;int bfs(int s){    while(!q.empty())//  多组测试用例,可能队列不为空,所以首先要清空队列        q.pop();    node st,dt;    st.x=s;    st.step=0;    vis[st.x]=1;    q.push(st);    flag=0;    while(!q.empty())    {        st=q.front();        q.pop();        if(st.x==n)        {            flag=1;            return st.step;        }        for(int i=0; i<4; i++)            for(int j=0; j<=9; j++)            {                if(i==3 && j==0)                    continue;                else                {                    if(j!=st.x/d[i]%10)//判断该位是不是和现有数字相同                    {                        int tx=((st.x/d[i]/10)*10+j)*d[i]+st.x%d[i];// 通项                        if(!a[tx] && !vis[tx])                        {                            vis[tx]=1;                            dt.x=tx;                            dt.step=st.step+1;                            q.push(dt);                        }                    }                }            }    }    return -1;}int main(){    int cs,count;    scanf("%d",&cs);    prime();    while(cs--)    {        memset(vis,0,sizeof(vis));        scanf("%d%d",&m,&n);        if(m==n)            printf("0\n");        else        {            count=bfs(m);            if(flag)                printf("%d\n",count);            else                printf("Impossible\n");//注意找不着就输出Impossible        }    }    return 0;}


0 0
原创粉丝点击